var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import defaultProcessRequest from './processRequest.mjs';
export default function graphqlUploadExpress(_a = {}) {
    var { processRequest = defaultProcessRequest } = _a, processRequestOptions = __rest(_a, ["processRequest"]);
    function graphqlUploadExpressMiddleware(request, response, next) {
        if (!request.is('multipart/form-data'))
            return next();
        const requestEnd = new Promise((resolve) => request.on('end', resolve));
        const { send } = response;
        response.send =
            (...args) => {
                requestEnd.then(() => {
                    response.send = send;
                    response.send(...args);
                });
            };
        processRequest(request, response, processRequestOptions)
            .then((body) => {
            request.body = body;
            next();
        })
            .catch((error) => {
            if (error.status && error.expose)
                response.status(error.status);
            next(error);
        });
    }
    return graphqlUploadExpressMiddleware;
}
